from tkinter import *
from tkinter import messagebox
from tkinter import font as tkFont
import pygame, sys
from pygame.locals import *
import time
import keyboard
from random import randint
all_sprites = pygame.sprite.Group()
pygame.init()
pygame.joystick.init()
joysticks = [pygame.joystick.Joystick(i) for i in range(pygame.joystick.get_count())]
window = None
clock = pygame.time.Clock()
fps = 60
fontobj = pygame.font.Font("freesansbold.ttf", 10)
player = None
highscore = 0
last_try = 0
volume = 1.0
jumpsound = pygame.mixer.Sound("sounds/jump1.wav")
winsound = pygame.mixer.Sound("sounds/100pt.wav")
highscoresound = pygame.mixer.Sound("sounds/highscore.wav")
sounds = [jumpsound, winsound, highscoresound]
background1 = pygame.image.load("sprites/ground.PNG")
background2 = pygame.image.load("sprites/ground2.PNG")
background3 = pygame.image.load("sprites/ground3.PNG")
backgrounds = [background1, background2, background3]
for sound in sounds:
    sound.set_volume(volume)
    background_e = None
all_spikes = []
all_stars = []
volume_p = None
volume_m = None
volume_e = None
speed_e = None
speed = 15
counter = 2
background = backgrounds[counter-1]
class Object(pygame.sprite.Sprite):
    def __init__(self, image, pos_x, pos_y, scalex, scaley, type, tag):
        pygame.sprite.Sprite.__init__(self)
        self.picture = image
        self.image = self.picture
        self.image = pygame.transform.scale(self.image, (scalex, scaley))
        self.rect = self.image.get_rect()
        self.pos_x = pos_x
        self.pos_y = pos_y
        self.scalex = scalex
        self.scaley = scaley
        self.rect.x = pos_x
        self.rect.y = pos_y
        self.type = type
        self.ground = None
        self.tag = tag
        self.x = 0
    def update(self):
        if self.type == 1:
            if self.rect.x+self.scalex == 20:
                if self.tag == "ground":
                    self.rect.x = self.pos_x
        if self.type == 1:
            if self.rect.x + self.scalex <= 20:
                if self.tag == "star":
                    self.x = randint(200, 600)
                    self.y = randint(10, 300)
                    self.rect.x = self.x
                    self.rect.y = self.y
        if self.type == 2:
            self.rect.x = self.ground.rect.x + 500
class Spike(pygame.sprite.Sprite):
    def __init__(self, speed, scalex, scaley, tag):
        pygame.sprite.Sprite.__init__(self)
        self.picture = pygame.image.load("sprites/spike.PNG")
        self.image = self.picture
        self.image = pygame.transform.scale(self.image, (scalex, scaley))
        self.rect = self.image.get_rect()
        self.rect.x = 504
        self.rect.y = 350
        self.speed = speed
        self.instantiate = False
        self.possibility = True
        self.tag = tag
    def update(self):
        global highscore
        global last_try
        global highscoresound
        if self.rect.x > player.rect.x:
            if self.rect.colliderect(player):
                if player.coins > highscore:
                    pygame.mixer.Sound.play(highscoresound)
                    highscore = player.coins
                last_try = player.coins
                game.button = False
                game.start()
        self.possibility = True
        for spike in all_spikes:
            if spike.tag != self.tag:
                if spike.instantiate == True:
                    if spike.rect.x > 100:
                        self.possibility = False
        if self.instantiate == False:
            if self.possibility == True:
                x = randint(0, 25)
                if x == 5:
                    self.instantiate = True
        if self.rect.x > 0:
            if self.instantiate == True:
                self.rect.x -= self.speed
        else:
            self.instantiate = False
            self.rect.x = 504
class Player(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y, scalex, scaley, speed, hearts, ground):
        global highscore
        global last_try
        global counter
        pygame.sprite.Sprite.__init__(self)
        self.picture = pygame.image.load("sprites/static.PNG")
        self.move1 = pygame.image.load("sprites/static.png")
        self.move2 = pygame.image.load("sprites/move1.png")
        self.move3 = pygame.image.load("sprites/move2.png")
        self.jump_img = pygame.image.load("sprites/jump.png")
        self.images = [self.move1, self.move2, self.move3]
        self.sprite = 1
        self.image = self.images[self.sprite]
        self.image = pygame.transform.scale(self.image, (scalex, scaley))
        self.rect = self.image.get_rect()
        self.rect = self.rect.inflate(-30, -30)
        #self.rect = self.rect.move(scalex, scaley)
        self.pos_x = pos_x
        self.pos_y = pos_y
        self.rect.x = pos_x
        self.rect.y = pos_y
        self.scalex = scalex
        self.scaley = scaley
        self.speed = speed
        self.hearts = hearts
        self.change_flag = True
        self.ground = ground
        self.grounded = True
        self.coins = 0
        if counter == 1:
            self.color = (0, 0, 0)
        else:
            self.color = (255, 255, 255)
        self.fontsurfobj = fontobj.render("coins: " + str(self.coins), True, (0, 0, 0))
        self.fontsurfobj2 = fontobj.render("highscore: " + str(highscore), True, (0, 0, 0))
        self.fontsurfobj3 = fontobj.render("last try: "+str(last_try), True, (0, 0, 0))
        self.gravity = 8
        self.value = 0
    def jump(self):
        pygame.mixer.Sound.play(jumpsound)
        self.rect.y -= 160
    def update(self):
        global highscore
        global last_try
        global all_stars
        self.coins += 2
        self.value += 2
        self.fontsurfobj = fontobj.render("coins: " + str(self.coins), True, self.color)
        self.fontsurfobj2 = fontobj.render("highscore: " + str(highscore), True, self.color)
        self.fontsurfobj3 = fontobj.render("last try: " + str(last_try), True, self.color)
        if self.grounded == True:
            if self.sprite < len(self.images)-1:
                self.sprite+=0.09
            else:
                self.sprite = 0
        else:
            self.image = self.jump_img
            self.image = pygame.transform.scale(self.image, (self.scalex, self.scaley))
        if self.grounded == True:
            self.image = self.images[int(self.sprite)]
            self.image = pygame.transform.scale(self.image, (self.scalex, self.scaley))
        if self.value == 1000:
            self.value = 0
            pygame.mixer.Sound.play(winsound)
        if self.rect.y < self.pos_y:
            self.grounded = False
        else:
            self.grounded = True
        if keyboard.is_pressed("space") == False:
            self.change_flag = True
        if keyboard.is_pressed("space"):
            if self.change_flag == True:
                if self.rect.y == self.pos_y:
                    self.change_flag = False
                    self.jump()

        self.ground.rect.x -= 2
        for star in all_stars:
            star.rect.x -= 2
class Game():
    def __init__(self):
        self.status = 1
        self.existence = False
        self.menu = None
        self.options = None
        self.counter = 0
        self.button = True
    def start(self):
        global window
        global player
        global all_spikes
        global all_stars
        global background
        global counter
        global speed
        self.counter +=1
        self.status = 3
        if self.button == True:
            self.menu.destroy()
            window = pygame.display.set_mode((500, 500))
            pygame.display.set_caption("Robot-main")
        else:
            self.button = True
        if self.counter > 1:
            all_sprites.empty()
        ground = Object(background, 0, 50, 520, 520, 1, "ground")
        ground2 = Object(background, 0, 50, 520, 520, 2, "ground")
        star = Object(pygame.image.load("sprites/star.PNG"), randint(200, 700), randint(10, 300), 30, 30, 1, "star")
        star2 = Object(pygame.image.load("sprites/star.PNG"), randint(200, 700), randint(10, 300), 30, 30, 1, "star")
        star3 = Object(pygame.image.load("sprites/star.PNG"), randint(200, 700), randint(10, 300), 30, 30, 1, "star")
        star4 = Object(pygame.image.load("sprites/star.PNG"), randint(200, 700), randint(10, 300), 30, 30, 1, "star")
        star5 = Object(pygame.image.load("sprites/star.PNG"), randint(200, 700), randint(10, 300), 30, 30, 1, "star")
        spike = Spike(speed, 50, 50, "spike")
        spike2 = Spike(speed, 50, 50, "spike2")
        spike3 = Spike(speed, 50, 50, "spike3")
        ground2.ground = ground
        player = Player(10, 290, 120, 120, 1, 3, ground)
        all_spikes = [spike, spike2, spike3]
        all_stars = [star, star2, star3, star4, star5]
        if counter == 2:
            all_sprites.add(star, star2, star3, star4, star5,)
        all_sprites.add(ground, ground2,spike, spike2, spike3, player)
    def quit(self):
        self.menu.destroy()
        sys.exit()
    def add_volume(self):
        global volume
        global background_p
        global background_m
        global volume_e
        global sounds
        if volume !=1.0:
            volume = round(volume+0.1, 2)
        for sound in sounds:
            sound.set_volume(volume)
            if sound == jumpsound:
                sound.play()
        volume_e.configure(state="normal")
        volume_e.delete(0, "end")
        volume_e.insert(0, str(volume))
        volume_e.configure(state="disabled")
    def deduct_volume(self):
        global volume
        global sounds
        global background_p
        global background_m
        global volume_e
        global sounds
        if volume !=0.0:
            volume = round(volume-0.1, 2)
        for sound in sounds:
            sound.set_volume(volume)
            if sound == jumpsound:
                sound.play()
        volume_e.configure(state="normal")
        volume_e.delete(0, "end")
        volume_e.insert(0, str(volume))
        volume_e.configure(state="disabled")
    def add_background(self):
        global background
        global backgrounds
        global background_e
        global counter
        if counter != 3:
            counter+=1
        background = backgrounds[counter-1]
        background_e.configure(state="normal")
        background_e.delete(0, "end")
        background_e.insert(0, str(counter))
        background_e.configure(state="disabled")
    def deduct_background(self):
        global background
        global backgrounds
        global background_e
        global counter
        if counter != 1:
            counter -= 1
        background = backgrounds[counter - 1]
        background_e.configure(state="normal")
        background_e.delete(0, "end")
        background_e.insert(0, str(counter))
        background_e.configure(state="disabled")
    def add_speed(self):
        global speed
        global speed_e
        if speed != 20:
            speed += 1
        speed_e.configure(state="normal")
        speed_e.delete(0, "end")
        speed_e.insert(0, str(speed))
        speed_e.configure(state="disabled")
    def deduct_speed(self):
        global speed
        global speed_e
        if speed != 7:
            speed -= 1
        speed_e.configure(state="normal")
        speed_e.delete(0, "end")
        speed_e.insert(0, str(speed))
        speed_e.configure(state="disabled")
    def settings(self):
        global background_m
        global background_p
        global background_e
        global volume
        global volume_e
        global counter
        global speed
        global speed_e
        self.options = Tk()
        self.options.title("Robot-settings")
        self.options.geometry("300x350")
        self.options.resizable(0, 0)
        canvas = Canvas(self.options, bg="black", width=310, height=350)
        font = tkFont.Font(family='Comic Sans MS', size=10)
        volume_label = Label(self.options, text="volume:", bg="#00ffff", font=font)
        volume_e = Entry(self.options, width=30)
        volume_e.insert(0, str(volume))
        volume_e.configure(state="disabled")
        volume_p = Button(self.options, text="+", command=self.add_volume, width=2, height=1, bg="#00ffff", fg="black",
                          activebackground="black", font=font)
        volume_m = Button(self.options, text="-", command=self.deduct_volume, width=2, height=1, bg="#00ffff",
                          fg="black", activebackground="black", font=font)
        background_label = Label(self.options, text="ground:", bg="#00ffff", font=font)
        background_e = Entry(self.options, width=30)
        background_e.insert(0, str(counter))
        background_e.configure(state="disabled")
        background_p = Button(self.options, text="+", command=self.add_background, width=2, height=1, bg="#00ffff",
                              fg="black", activebackground="black", font=font)
        background_m = Button(self.options, text="-", command=self.deduct_background, width=2, height=1, bg="#00ffff",
                              fg="black", activebackground="black", font=font)
        speed_label = Label(self.options, text="speed", bg="#00ffff", font=font)
        speed_e = Entry(self.options, width=30)
        speed_e.insert(0, str(speed))
        speed_e.configure(state="disabled")
        speed_p = Button(self.options, text="+", command=self.add_speed, width=2, height=1, bg="#00ffff", fg="black",
                         activebackground="black", font=font)
        speed_m = Button(self.options, text="-", command=self.deduct_speed, width=2, height=1, bg="#00ffff", fg="black",
                         activebackground="black", font=font)
        canvas.place(x=-10, y=0)
        volume_label.place(x=115, y=10)
        volume_e.place(x=57, y=50)
        volume_p.place(x=250, y=40)
        volume_m.place(x=15, y=40)
        background_label.place(x=115, y=90)
        background_e.place(x=57, y=130)
        background_p.place(x=250, y=120)
        background_m.place(x=15, y=120)
        speed_label.place(x=115, y=170)
        speed_e.place(x=57, y=210)
        speed_p.place(x=250, y=200)
        speed_m.place(x=15, y=200)
        self.options.update()
    def open_menu(self):
        self.menu = Tk()
        self.menu.title("Robot-menu")
        self.menu.geometry("300x350")
        self.menu.resizable(0, 0)
        canvas = Canvas(self.menu, bg="black", width=310, height=350)
        font = tkFont.Font(family='Comic Sans MS', size=10)
        start = Button(text="Start", width=25, height=2, command=self.start, bg="#00ffff", fg="black",
                       activebackground="black", font=font)
        exit = Button(text="Quit", width=25, height=2, command=self.quit, bg="#00ffff", fg="black",
                      activebackground="black", font=font)
        settings = Button(text="Settings", width=25, height=2, command=self.settings, bg="#00ffff", fg="black",
                          activebackground="black", font=font)
        label = Label(text="main sprite by Sol", bg="black", fg="white")
        canvas.place(x=-10, y=0)
        start.place(x=45, y=150)
        exit.place(x=45, y=225)
        settings.place(x=45, y=75)
        label.place(x=100, y=330)
        self.menu.update()
        self.menu.mainloop()
    def update(self):
        if self.status == 1:
            self.open_menu()
game = Game()
game.update()
while True:
    if game.status == 3:
        all_sprites.update()
        all_sprites.draw(window)
        pygame.display.update()
        clock.tick(fps)
        if counter == 1:
            window.fill((0,191,255))
        if counter == 2:
            window.fill((0, 0, 0))
        if counter ==3:
            window.fill((0, 0, 0))
        window.blit(player.fontsurfobj, (10, 5))
        window.blit(player.fontsurfobj2, (10, 20))
        window.blit(player.fontsurfobj3, (10, 35))
        if player.grounded == False:
            player.rect.y += player.gravity
    if keyboard.is_pressed("r"):
        highscore = 0
        last_try = 0
        game.button = False
        game.start()
    if keyboard.is_pressed("e"):
        pygame.quit()
        sys.exit()
    for event in pygame.event.get():
        if event.type == JOYBUTTONDOWN:
            #print(event)
            if event.button == 0:
                if player.rect.y == player.pos_y:
                    player.change_flag = False
                    player.jump()
            if event.button == 5:
                highscore = 0
                last_try = 0
                game.button = False
                game.start()
            if event.button == 7:
                pygame.display.quit()
                game.status = 1
                game.update()
        if event.type == QUIT:
            pygame.display.quit()
            game.status = 1
            game.update()

